﻿Imports System.Data
Imports Infragistics.Windows.DockManager
Imports System.Threading
Imports Infragistics.Windows.DataPresenter
Imports Infragistics.Controls.Maps
Imports Infragistics.Controls.Charts

Class MainWindow
    Public source As New DataTable ' Test

    Private additionalInfoThread As Thread

    Public Event additionalInfoThreadComplete()

    Public Delegate Sub updateAdditionalDelegate(info As DataTable)

    Public delUodateAdditionalInfo As updateAdditionalDelegate
    Private UpNodeStyle As System.Windows.Style
    Private RootNodeStyle As System.Windows.Style
    Private DownNodeStyle As System.Windows.Style


    Sub New()

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        UpNodeStyle = DirectCast(Me.Resources("UpNodeStyle"), System.Windows.Style)
        RootNodeStyle = DirectCast(Me.Resources("RootNodeStyle"), System.Windows.Style)
        DownNodeStyle = DirectCast(Me.Resources("DownNodeStyle"), System.Windows.Style)
    End Sub
    Private Sub Button1_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)

        ' Configure open file dialog box
        Dim dlg As New Microsoft.Win32.OpenFileDialog()
        dlg.FileName = "Excel" ' Default file name
        dlg.DefaultExt = ".xls" ' Default file extension
        dlg.Filter = "Excel sheet (.xls)|*.xls" ' Filter files by extension

        ' Show open file dialog box
        Dim result? As Boolean = dlg.ShowDialog()

        ' Process open file dialog box results
        If result = True Then
            ' Open document
            Dim filename As String = dlg.FileName
            Dim dt As DataTable = GetDataFromExcel(filename).Tables(0)
        End If
    End Sub
    Public Function GetDataFromExcel(ByVal FileName As String) As System.Data.DataSet

        Try
            Dim strConn As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FileName & "; Extended Properties=Excel 8.0;"
            Dim objConn _
                As New System.Data.OleDb.OleDbConnection(strConn)
            objConn.Open()
            ' Create objects ready to grab data
            Dim objCmd As New System.Data.OleDb.OleDbCommand( _
                "select * from [Tabelle1$]", objConn)
            Dim objDA As New System.Data.OleDb.OleDbDataAdapter()
            objDA.SelectCommand = objCmd
            ' Fill DataSet
            Dim objDS As New System.Data.DataSet()
            objDA.Fill(objDS)
            ' Clean up and return DataSet
            objConn.Close()
            Return objDS
        Catch
            ' Possible errors include Excel file already open and
            ' locked, et al.
            Return Nothing
        End Try
    End Function


    Private Sub articleGrid_CellActivating(sender As Object, e As Infragistics.Windows.DataPresenter.Events.CellActivatingEventArgs) Handles articleGrid.CellActivating
       
            If Not additionalInfoThread Is Nothing AndAlso additionalInfoThread.IsAlive Then
                additionalInfoThread.Abort()
            End If

            additionalInfoThread = New Thread(AddressOf getAdditionalArticleInfo)

            additionalInfoThread.Start(source)
       


    End Sub

    Private Sub generateSampleData1()
        If source Is Nothing Then
            source = New DataTable
        End If
        If source.Columns.Count <= 0 Then
            Dim Items As Integer = 10
            For i = 0 To Items
                source.Columns.Add(New DataColumn("Item" & i, GetType(Double)))
            Next
            For i As Integer = 0 To Items
                Dim dr As DataRow = source.NewRow()
                For j As Integer = 0 To Items
                    dr("Item" & j) = j
                Next
                source.Rows.Add(dr)

            Next
        End If
    End Sub


    Private Sub getAdditionalArticleInfo(info As DataTable)
        RaiseEvent additionalInfoThreadComplete()
    End Sub

    Private Sub refreshAdditionalDetails(info As DataTable)
        dynamicDock.Panes.Clear()
        For i As Integer = 0 To 4
            Dim contPane As ContentPane
            contPane = New ContentPane
            contPane.AllowClose = False
            contPane.AllowDocking = False
            contPane.AllowPinning = False
            contPane.AllowDrop = False
            contPane.AllowDockingLeft = False
            contPane.AllowDockingRight = False
            contPane.AllowDockingBottom = False
            contPane.AllowDockingTop = False
            contPane.PinButtonVisibility = Windows.Visibility.Hidden
            contPane.CloseButtonVisibility = Windows.Visibility.Hidden
            contPane.AllowDockingInTabGroup = False
            contPane.WindowPositionMenuVisibility = Windows.Visibility.Hidden
            contPane.AllowDockingFloating = False
            Dim btnMax As New Button
            btnMax.Content = "max"
            contPane.Header = btnMax
            AddHandler btnMax.Click, AddressOf btnMaxClick
            AddHandler contPane.SizeChanged, AddressOf contPaneSizeChanged

            'Networknode
            Dim GraphData As New SimpleGraphData
            Dim xnn As New XamNetworkNode
            xnn.Name = "xnn" & i.ToString
            AddHandler xnn.NodeControlAttachedEvent, AddressOf NodeControlAttached
            xnn.ItemsSource = GraphData.Nodes
            Dim xnnl As New NetworkNodeNodeLayout
            Dim xnnlc As New NetworkNodeNodeLayoutCollection
            xnnl.ItemTemplate = DirectCast(Me.Resources("NodeTemplate"), DataTemplate)
            xnnl.TargetTypeName = "NodeModel"
            xnnl.DisplayMemberPath = "NodeCaption"
            xnnl.ToolTipMemberPath = "ToolTip"
            xnnl.ConnectionsMemberPath = "Connections"
            xnnl.ConnectionTargetMemberPath = "Target"
            xnnlc.Add(xnnl)
            xnn.GlobalNodeLayouts = xnnlc

            AddHandler xnn.SizeChanged, AddressOf netWorkNodeSizeChanged

            contPane.Content = xnn
            dynamicDock.Panes.Add(contPane)

        Next
       
    End Sub

    Private Sub refreshDatagrid(info As DataTable, dg As XamDataGrid)
        dg.DataSource = info.DefaultView
    End Sub

    Private Sub MainWindow_additionalInfoThreadComplete() Handles Me.additionalInfoThreadComplete
        delUodateAdditionalInfo = New updateAdditionalDelegate(AddressOf refreshAdditionalDetails)
        Dispatcher.BeginInvoke(delUodateAdditionalInfo, New Object() {source})
    End Sub

  

    Private Sub btnMaxClick(sender As Object, e As RoutedEventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        Dim parentContentPane As ContentPane = DirectCast(DirectCast(sender, System.Windows.Controls.Button).Parent, Infragistics.Windows.DockManager.ContentPane)
        Dim parentSplitPane As SplitPane = DirectCast(parentContentPane.Parent, Infragistics.Windows.DockManager.SplitPane)
        parentSplitPane.Width = Me.ActualWidth / 2
        For Each cp As ContentPane In parentSplitPane.Panes
            If Not cp Is parentContentPane Then
                cp.Visibility = Windows.Visibility.Collapsed
            End If
        Next
        btn.Content = "Restore"
        AddHandler btn.Click, AddressOf btnRestoreClick
    End Sub

    Private Sub btnRestoreClick(sender As Object, e As RoutedEventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        Dim parentContentPane As ContentPane = DirectCast(DirectCast(sender, System.Windows.Controls.Button).Parent, Infragistics.Windows.DockManager.ContentPane)
        Dim parentSplitPane As SplitPane = DirectCast(parentContentPane.Parent, Infragistics.Windows.DockManager.SplitPane)
        parentSplitPane.Width = 250
        For Each cp As ContentPane In parentSplitPane.Panes
            If Not cp Is parentContentPane Then
                cp.Visibility = Windows.Visibility.Visible
            End If
        Next
        btn.Content = "max"
        AddHandler btn.Click, AddressOf btnMaxClick
    End Sub

    Private Sub NodeControlAttached(sender As Object, e As NetworkNodeEventArgs)
        Dim n As NodeModel = TryCast(e.NodeControl.DataContext, NodeModel)
        If n.NodeLevel = 0 Then
            e.NodeControl.Style = RootNodeStyle
        ElseIf n.NodeLevel > 0 Then
            e.NodeControl.Style = UpNodeStyle
        ElseIf n.NodeLevel < 0 Then
            e.NodeControl.Style = DownNodeStyle
        End If
    End Sub

    Private Sub netWorkNodeSizeChanged(sender As Object, e As SizeChangedEventArgs)
        Dim xnn As XamNetworkNode = DirectCast(sender, XamNetworkNode)
        xnn.ScaleToFit()
    End Sub

    Private Sub contPaneSizeChanged(sender As Object, e As SizeChangedEventArgs)
        Dim cp As ContentPane = DirectCast(sender, ContentPane)
        If TypeOf cp.Content Is XamNetworkNode Then
            Dim xnn As XamNetworkNode = DirectCast(cp.Content, XamNetworkNode)
            xnn.ScaleToFit()
        End If
    End Sub

    Private Sub dynamicDock_SizeChanged(sender As Object, e As System.Windows.SizeChangedEventArgs) Handles dynamicDock.SizeChanged
        For Each cp As ContentPane In dynamicDock.Panes
            If TypeOf cp.Content Is XamNetworkNode Then
                Dim xnn As XamNetworkNode = DirectCast(cp.Content, XamNetworkNode)
                xnn.ScaleToFit()
            End If
        Next
    End Sub

End Class
