﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel

Public Class NodeModel
    Implements INotifyPropertyChanged

    Private _nodeCaption As String
    Public Property NodeCaption() As String
        Get
            Return _nodeCaption
        End Get
        Set(value As String)
            If value <> _nodeCaption Then
                _nodeCaption = value
                NotifyPropertyUpdated("NodeCaption")
            End If
        End Set
    End Property

    Private _nodeLevel As Integer
    Public Property NodeLevel As Integer
        Get
            Return _nodeLevel
        End Get
        Set(value As Integer)
            _nodeLevel = value
            NotifyPropertyUpdated("NodeLevel")
        End Set
    End Property

    Private _toolTip As String
    Public Property ToolTip() As String
        Get
            Return _toolTip
        End Get
        Set(value As String)
            If value <> _toolTip Then
                _toolTip = value
                NotifyPropertyUpdated("ToolTip")
            End If
        End Set
    End Property

    Private _connections As ObservableCollection(Of ConnectionModel)
    Public Property Connections() As ObservableCollection(Of ConnectionModel)
        Get
            Return _connections
        End Get
        Set(value As ObservableCollection(Of ConnectionModel))
            If Not value Is Connections Then
                _connections = value
                NotifyPropertyUpdated("Connections")
            End If


        End Set
    End Property

    Private _id As Integer
    Public Property ID As Integer
        Get
            Return _id
        End Get
        Set(value As Integer)
            _id = value
            NotifyPropertyUpdated("ID")
        End Set
    End Property



    Public Event PropertyChanged As PropertyChangedEventHandler Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Overridable Sub NotifyPropertyUpdated(propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub


End Class