﻿Imports System.Collections.ObjectModel
Imports System.Data

Public Class SimpleGraphData
    Public Property Nodes() As ObservableCollection(Of NodeModel)
        Get
            Return m_Nodes
        End Get
        Set(value As ObservableCollection(Of NodeModel))
            m_Nodes = value
        End Set
    End Property
    Private m_Nodes As ObservableCollection(Of NodeModel)
    Public Sub New()
        Nodes = New ObservableCollection(Of NodeModel)
        Dim data As DataTable = GetDataFromExcel(System.IO.Directory.GetCurrentDirectory & "/Network.xls").Tables(0)
        'Dim rootTable As DataRow() = data.Select("deID = 0")
        For Each row As DataRow In data.Rows
            Dim node As New NodeModel()
            node.ID = Convert.ToInt32(row.Item("MainID"))
            node.NodeCaption = row.Item("Description1").ToString
            node.ToolTip = row.Item("Description2").ToString
            node.NodeLevel = Convert.ToInt32(row.Item("Direction"))
            Nodes.Add(node)
        Next

        For Each n As NodeModel In Nodes
            n = getSubNodes(n, data, Nodes)
        Next
        '' add NUM_NODES node objects to the collection
        'For i As Integer = 0 To NUM_NODES - 1
        '    Dim node As New NodeModel()
        '    node.Label = i.ToString()
        '    node.ToolTip = "ToolTip for " & node.Label
        '    Nodes.Add(node)
        'Next

        '' starting with node 0, set that node as the root.
        '' add up to K connections to the root node.
        '' then, increment the root node index and repeat until all nodes have been connected.
        'Dim root As Integer = 0
        'Dim first As Integer = 1
        'Dim last As Integer = K
        'While first < Nodes.Count
        '    Nodes(root).Connections = New ObservableCollection(Of ConnectionModel)()
        '    For i As Integer = first To last
        '        If i >= Nodes.Count Then
        '            Exit For
        '        End If
        '        Dim newCon As New ConnectionModel
        '        newCon.Target = Nodes(i)
        '        Nodes(root).Connections.Add(newCon)
        '    Next
        '    root += 1
        '    first = last + 1
        '    last += K
        'End While

    End Sub

    Private Function getNodeByID(ID As Integer, nodes As ObservableCollection(Of NodeModel)) As NodeModel
        For Each n As NodeModel In nodes
            If n.ID = ID Then
                Return n
            End If
        Next
        Return Nothing
    End Function

    Private Function getSubNodes(n As NodeModel, data As DataTable, nodes As ObservableCollection(Of NodeModel)) As NodeModel
        Dim childTable As DataRow() = data.Select("deID = " & n.ID.ToString)
        If childTable.Length > 0 Then
            n.Connections = New ObservableCollection(Of ConnectionModel)
            For Each row As DataRow In childTable

                Dim conn As New ConnectionModel
                conn.Target = getNodeByID(row.Item("MainID"), nodes)
                n.Connections.Add(conn)
            Next
        End If
        Return n
    End Function

    Public Function GetDataFromExcel(ByVal FileName As String) As System.Data.DataSet

        Try
            Dim strConn As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FileName & "; Extended Properties=Excel 8.0;"
            Dim objConn _
                As New System.Data.OleDb.OleDbConnection(strConn)
            objConn.Open()
            ' Create objects ready to grab data
            Dim objCmd As New System.Data.OleDb.OleDbCommand( _
                "select * from [Tabelle1$]", objConn)
            Dim objDA As New System.Data.OleDb.OleDbDataAdapter()
            objDA.SelectCommand = objCmd
            ' Fill DataSet
            Dim objDS As New System.Data.DataSet()
            objDA.Fill(objDS)
            ' Clean up and return DataSet
            objConn.Close()
            Return objDS
        Catch
            ' Possible errors include Excel file already open and
            ' locked, et al.
            Return Nothing
        End Try
    End Function
End Class
